function date_index = get_date_index(n_month, day)
% -----------------------------------------------------------------------
% Funcin "get_date_index":
%     sta funcin calcula el nmero de columna del fichero de datos de
% Meteonorm "standard minute" al que corresponde la fecha proporcionada,
% en forma de nmero de mes y nmero de da.
% -----------------------------------------------------------------------

% Comprobacin de errores en el mes
if n_month > 12 || n_month < 1
    date_index = -1;
else
    date_index = 0;

    if n_month == 1 % Si es enero
        date_index = 0;
    else % Para el resto de meses
        for i = 1:n_month-1
            date_index = date_index + get_days_month(i);
        end
    end
    % Comprobacin de errores en el da
    if day > get_days_month(n_month) || day < 1
        date_index = -1;
    else
        % Se aade el nmero de das y se multiplica por el nmero
        % de minutos de un da
        date_index = (date_index + day)*1440;
    end
end

