function [G_Bn, Ta] = meteonorm_file(filename)
% -----------------------------------------------------------------------
% Funcin "meteonorm_file":
%     Funcin encargada de la lectura de los datos relevantes del
% fichero "standard minute" proporcionados por la aplicacin Meteonorm
% 6.0. Lee la radiacin solar global horizontal por minuto y la
% temperatura ambiente por minuto.
% -----------------------------------------------------------------------

% Apertura del fichero
fid = fopen( filename, 'r' );
% Seleccin del formato de lectura, para leer slo una columna
formatSpec = '%*d%*d%*d%*d%*d%d%*f%*d%*d%*d%*d%*d%*f'; % G_Gh
G_Bn = cell2mat(textscan(fid, formatSpec)).';
frewind(fid); % Rebobinamos ndice de lectura del fichero

formatSpec = '%*d%*d%*d%*d%*d%*d%*f%*d%*d%*d%*d%*d%f'; % Ta
Ta = cell2mat(textscan(fid, formatSpec)).';

% Cierre del fichero
fclose(fid);
