classdef PreciSol < matlab.apps.AppBase

    % Properties that correspond to app components
    properties (Access = public)
        PreciSolApp             matlab.ui.Figure                   % PreciSol
        Graficas                matlab.ui.container.TabGroup       % I-V, P...
        IV                      matlab.ui.container.Tab            % I-V
        IVGraph                 matlab.ui.control.UIAxes           % Corrie...
        PV                      matlab.ui.container.Tab            % P-V
        PVGraph                 matlab.ui.control.UIAxes           % Potenc...
        T                       matlab.ui.container.Tab            % T
        TGraph                  matlab.ui.control.UIAxes           % Temper...
        G                       matlab.ui.container.Tab            % G
        GGraph                  matlab.ui.control.UIAxes           % Irradi...
        Pot                     matlab.ui.container.Tab            % Potenc...
        PotGraph                matlab.ui.control.UIAxes           % Potenc...
        Datos                   matlab.ui.container.Tab            % Datos
        LabelNumericEditField2  matlab.ui.control.Label            % Potenc...
        PotenciaAcumulada       matlab.ui.control.NumericEditField % [-Inf ...
        PotenciaAcumuladaUnidad matlab.ui.control.EditField       
        RendSTCUnidad           matlab.ui.control.EditField       
        Label4                  matlab.ui.control.Label            % Rendim...
        RendSTC                 matlab.ui.control.NumericEditField % [-Inf ...
        RendObtUnidad           matlab.ui.control.EditField       
        Label5                  matlab.ui.control.Label            % Rend. ...
        RendObt                 matlab.ui.control.NumericEditField % [-Inf ...
        RendAvgUnidad           matlab.ui.control.EditField       
        Label6                  matlab.ui.control.Label            % Rendim...
        RendAvg                 matlab.ui.control.NumericEditField % [-Inf ...
        PotSTCUnidad            matlab.ui.control.EditField       
        Label22                 matlab.ui.control.Label            % Potenc...
        PotSTC                  matlab.ui.control.NumericEditField % [-Inf ...
        Label28                 matlab.ui.control.Label            % Voltaj...
        VoltMax                 matlab.ui.control.NumericEditField % [-Inf ...
        Label29                 matlab.ui.control.Label            % Corrie...
        IntMax                  matlab.ui.control.NumericEditField % [-Inf ...
        Label30                 matlab.ui.control.Label            % Voltaj...
        VoltAvg                 matlab.ui.control.NumericEditField % [-Inf ...
        Label31                 matlab.ui.control.Label            % Corrie...
        IntAvg                  matlab.ui.control.NumericEditField % [-Inf ...
        VoltMaxUnidad           matlab.ui.control.EditField       
        VoltAvgUnidad           matlab.ui.control.EditField       
        IntMaxUnidad            matlab.ui.control.EditField       
        IntAvgUnidad            matlab.ui.control.EditField       
        Utilidades              matlab.ui.container.Tab            % Utilid...
        Label20                 matlab.ui.control.Label            % File f...
        FileFuser               matlab.ui.control.Button           % Fusion...
        Label23                 matlab.ui.control.Label            % Calcul...
        CalcRes1                matlab.ui.control.Button           % 1 diodo
        CalcRes2                matlab.ui.control.Button           % 2 diodos
        TempModulo              matlab.ui.container.Tab            % Tc
        TcGraph                 matlab.ui.control.UIAxes           % Temper...
        TensionPmax             matlab.ui.container.Tab            % V
        TensGraph               matlab.ui.control.UIAxes           % Tensi...
        CorrientePmax           matlab.ui.container.Tab            % I
        CorrGraph               matlab.ui.control.UIAxes           % Corrie...
        Simular                 matlab.ui.control.Button           % Simular
        Label                   matlab.ui.control.Label            % Simula...
        MeteoData               matlab.ui.container.Panel          % Datos ...
        CargarData              matlab.ui.control.Button           % Cargar
        EliminarData            matlab.ui.control.Button           % Eliminar
        LabelListBox2           matlab.ui.control.Label            % Archivos
        ListaData               matlab.ui.control.ListBox         
        LabelDropDown2          matlab.ui.control.Label            % Mes
        ComienzoMes             matlab.ui.control.DropDown         % Enero,...
        Label3                  matlab.ui.control.Label            % Da
        ComienzoDia             matlab.ui.control.DropDown         % 1, 2, ...
        FechaMode               matlab.ui.container.ButtonGroup    % Modo
        ModoHora                matlab.ui.control.RadioButton      % Hora
        ModoMinuto              matlab.ui.control.RadioButton      % Minuto
        Label16                 matlab.ui.control.Label            % Mes
        FinalMes                matlab.ui.control.DropDown         % Enero,...
        Label17                 matlab.ui.control.Label            % Da
        FinalDia                matlab.ui.control.DropDown         % 1, 2, ...
        Label18                 matlab.ui.control.Label            % Comienzo
        Label19                 matlab.ui.control.Label            % Final
        Modulos                 matlab.ui.container.Panel          % Mdulos
        CargarModulos           matlab.ui.control.Button           % Cargar
        EliminarModulos         matlab.ui.control.Button           % Eliminar
        Label2                  matlab.ui.control.Label            % Tipos
        ListaModulos            matlab.ui.control.ListBox         
        ModeloModulo            matlab.ui.control.EditField       
        LabelNumericEditField4  matlab.ui.control.Label            % Voc (V)
        ModuloVoc               matlab.ui.control.NumericEditField % [-Inf ...
        Label7                  matlab.ui.control.Label            % Isc (A)
        ModuloIsc               matlab.ui.control.NumericEditField % [-Inf ...
        Label8                  matlab.ui.control.Label            % Ki
        ModuloKi                matlab.ui.control.NumericEditField % [-Inf ...
        Label9                  matlab.ui.control.Label            % Kv
        ModuloKv                matlab.ui.control.NumericEditField % [-Inf ...
        Label10                 matlab.ui.control.Label            % Ns
        ModuloNs                matlab.ui.control.NumericEditField % [-Inf ...
        Label11                 matlab.ui.control.Label            % TONC
        ModuloTONC              matlab.ui.control.NumericEditField % [-Inf ...
        Label12                 matlab.ui.control.Label            % Vmp
        ModuloVmp               matlab.ui.control.NumericEditField % [-Inf ...
        Label13                 matlab.ui.control.Label            % Imp
        ModuloImp               matlab.ui.control.NumericEditField % [-Inf ...
        Label14                 matlab.ui.control.Label            % ? (%)
        ModuloRend              matlab.ui.control.NumericEditField % [-Inf ...
        Label15                 matlab.ui.control.Label            % Pmp
        ModuloPmp               matlab.ui.control.NumericEditField % [-Inf ...
        Label21                 matlab.ui.control.Label            % Superf...
        ModuloSup               matlab.ui.control.NumericEditField % [-Inf ...
        DatosSimulacion         matlab.ui.container.TabGroup       % Simula...
        DatosBasicos            matlab.ui.container.Tab            % Simula...
        LabelDiscreteKnob       matlab.ui.control.Label            % Precisin
        Precision               matlab.ui.control.DiscreteKnob     % 10, 10...
        Modelo                  matlab.ui.container.ButtonGroup    % Modelo...
        Diodo1Modelo            matlab.ui.control.RadioButton      % Modelo...
        Diodo2Modelo            matlab.ui.control.RadioButton      % Modelo...
        DatosPerdidas           matlab.ui.container.Tab            % Prdidas
        LabelNumericEditField5  matlab.ui.control.Label            % Prdid...
        PerFab                  matlab.ui.control.NumericEditField % [0 10]
        Label24                 matlab.ui.control.Label            % Prdid...
        PerVid                  matlab.ui.control.NumericEditField % [0 25]
        Label25                 matlab.ui.control.Label            % Prdid...
        PerSuc                  matlab.ui.control.NumericEditField % [0 100]
        Label26                 matlab.ui.control.Label            % Estoc...
        PerFabRand              matlab.ui.control.CheckBox        
        PerVidRand              matlab.ui.control.CheckBox        
        PerSucRand              matlab.ui.control.CheckBox        
        Tab                     matlab.ui.container.Tab            % N de ...
        LabelNumericEditField   matlab.ui.control.Label            % M. en ...
        ModulosSerie            matlab.ui.control.NumericEditField % [1 Inf]
        Label27                 matlab.ui.control.Label            % M. en ...
        ModulosParalelo         matlab.ui.control.NumericEditField % [1 Inf]
        LabelNumericEditField6  matlab.ui.control.Label            % M. tot...
        NumeroModulos           matlab.ui.control.NumericEditField % [-Inf ...
        Label32                 matlab.ui.control.Label            % Multip...
        MultiplicadorModulos    matlab.ui.control.NumericEditField % [1 Inf]
    end

    
    properties (Access = private)
        DataFileNames = cell(0) % Lista con los nombres de los ficheros de datos meteorolgicos cargados
        DataFilePaths = cell(0) % Lista con las rutas de los ficheros de datos meteorolgicos cargados
        ModuleFileNames = cell(0) % Lista con los nombres de los ficheros de parmetros de mdulo cargados
        ModuleFilePaths = cell(0) % Lista con las rutas de los ficheros de parmetros de mdulo cargados
        G_Gh = 0 % Variable vector con los datos de irradiancia globobtenidos del fichero de dat. meteo.
        Ta = 0 % Variable vector con los datos de temp. ambiente obtenidos del fichero de dat. meteo.
        ModuleName = '' % Variable con el nombre del mdulo cargado
        Rend = 0 % Var. con el rendimiento del mdulo cargado
        Voc = 0 % Var. con la tens. de cir. abierto del mdulo cargado
        Isc = 0 % Var. con la corr. de cortocircuito del mdulo cargado
        Pmp = 0 % Var. con la potencia mx. del mdulo cargado
        Imp = 0 % Var. con la corriente de P.M. del mdulo cargado
        Vmp = 0 % Var. con la tensin de P.M. del mdulo cargado
        Ns = 0 % Var. con el n de clulas del mdulo cargado
        Kv = 0 % Var. con el coef. de temp. sobre Voc del mdulo cargado
        Ki = 0 % Var. con el coef. de temp. sobre Isc del mdulo cargado
        Rs = 0 % Var. vector con la res. en serie del mdulo cargado para los dos modelos
        Rp = 0 % Var. vector con la res. en paralelo del mdulo cargado para los dos modelos
        TONC = 0 % Var. con la Temperatura de operacin nominal del mdulo cargado
        Sup = 0 % Var. con la superficie del mdulo cargado
    end
    

    methods (Access = private)

        % Code that executes after component creation
        function startupFcn(app)
            % Carga de los dos modelos de SIMULINK de 1 diodo y
            % dos diodos
            load_system('sim_1_diode'); % 1 diodo
            load_system('sim_2_diode'); % 2 diodos
        end

        % CargarData button pushed function
        function CargarDataButtonPushed(app)
            % Seleccionar fichero de datos
            [aux_name, aux_path] = uigetfile('.dat');
            % Aadimos un hueco ms a la lista de nombres de ficheros
            % de datos
            aux_size = size(app.DataFileNames);
            aux_size = aux_size(2);
            app.DataFileNames{aux_size + 1} = [];
            app.DataFilePaths{aux_size + 1} = [];
            % Escribimos en los nuevos elementos
            aux_size = size(app.DataFileNames);
            aux_size = aux_size(2);
            app.DataFileNames{aux_size} = aux_name;
            app.DataFilePaths{aux_size} = aux_path;
            % Actualizado de la lista grfica
            app.ListaData.Items = app.DataFileNames;
        end

        % EliminarData button pushed function
        function EliminarDataButtonPushed(app)
            % Deteccin de elemento a eliminar
            to_delete = app.ListaData.Value;
            % Determinamos tamao de la lista
            aux_size = size(app.DataFileNames);
            aux_size = aux_size(2);
            % Encontrar nombre de la lista a eliminar
            index_mat = strfind(app.DataFileNames, to_delete);
            for i = 1:length(index_mat)
                if (index_mat{i} == 1)
                    index_aux = i;
                    break;
                end
            end
            % Borrado del elemento de la lista
            app.DataFileNames = {app.DataFileNames{1:index_aux-1}, ...
                app.DataFileNames{index_aux+1:aux_size}};
            app.DataFilePaths = {app.DataFilePaths{1:index_aux-1}, ...
                app.DataFilePaths{index_aux+1:aux_size}};
            % Actualizado de la lista grfica
            app.ListaData.Items = app.DataFileNames;
        end

        % CargarModulos button pushed function
        function CargarModulosButtonPushed(app)
            % Seleccionar fichero de datos de mdulo
            [aux_name, aux_path] = uigetfile('.csv');
            % Aadimos un hueco ms a la lista de nombres de ficheros
            % de datos de mdulo
            aux_size = size(app.ModuleFileNames);
            aux_size = aux_size(2);
            app.ModuleFileNames{aux_size + 1} = [];
            app.ModuleFilePaths{aux_size + 1} = [];
            % Escribimos en los nuevos elementos
            aux_size = size(app.ModuleFileNames);
            aux_size = aux_size(2);
            app.ModuleFileNames{aux_size} = aux_name;
            app.ModuleFilePaths{aux_size} = aux_path;
            
            app.ListaModulos.Items = app.ModuleFileNames;
        end

        % EliminarModulos button pushed function
        function EliminarModulosButtonPushed(app)
            % Deteccin de elemento a eliminar
            to_delete = app.ListaModulos.Value;
            % Determinamos tamao de la lista
            aux_size = size(app.ModuleFileNames);
            aux_size = aux_size(2);
            % Encontrar nombre de la lista a eliminar
            index_mat = strfind(app.ModuleFileNames, to_delete);
            for i = 1:length(index_mat)
                if (index_mat{i} == 1)
                    index_aux = i;
                    break;
                end
            end
            % Borrado del elemento de la lista
            app.ModuleFileNames = {app.ModuleFileNames{1:index_aux-1}, ...
                app.ModuleFileNames{index_aux+1:aux_size}};
            app.ModuleFilePaths = {app.ModuleFilePaths{1:index_aux-1}, ...
                app.ModuleFilePaths{index_aux+1:aux_size}};
            % Actualizado de la lista grfica
            app.ListaModulos.Items = app.ModuleFileNames;
        end

        % Simular button pushed function
        function SimularButtonPushed(app)
            % ------------------------------------------------
            % Funcin asociada al boton "Simular", ejecuta los
            % modelos correspondientes para los datos
            % meteorolgicos seleccionados, utilizando los
            % parmetros de mdulo seleccionado, as como el
            % resto de opcines, como nmero de paneles,
            % precisin y modelo utilizado
            % ------------------------------------------------
            
            % Seleccin del modelo de simulacin
            if app.Diodo1Modelo.Value == 1 % 1 diodo
                module_mode = false; % Modo
            elseif app.Diodo2Modelo.Value == 1 % 2 diodos
                module_mode = true;
            end
            
            % Creacin de los ndices de comienzo y final de simulacin:
            % Comienzo
            n_month_start = get_month_num(app.ComienzoMes.Value);
            n_day_start = str2double(app.ComienzoDia.Value);
            date_index_start = get_date_index(n_month_start, n_day_start) - 1439;
            % Final
            n_month_end = get_month_num(app.FinalMes.Value);
            n_day_end = str2double(app.FinalDia.Value);
            date_index_end = get_date_index(n_month_end, n_day_end);
            
            if date_index_start > date_index_end ||...
                    length(app.G_Gh) == 0 ||...
                    strcmp(app.ModuleName, '') % Deteccin de errores
                if date_index_start > date_index_end % Fechas incorrectas
                    prompt='Fecha de comienzo mayor que la final';
                elseif length(app.G_Gh) == 0 % Datos meteo. no cargados
                    prompt='Datos meteorolgicos no cargados';
                elseif strcmp(app.ModuleName, '') % Datos de mod. no cargados
                    prompt='Datos de mdulo no cargados';
                end
                name = 'ERROR';
                warndlg(prompt, name);
            else
                % Seleccin de truncado de datos
                if app.ModoHora.Value == 1 % Datos en hora
                    t = date_index_start:60:date_index_end;
                    pot_divider = 1;
                else % Datos en minutos
                    t = date_index_start:date_index_end;
                    pot_divider = 60;
                end
                
                % Comienzo de ejecucin de la simulacin
                progressbar(0)
                progressbar('Progreso de la simulacin')
                % Inicializacin de vectores
                P = 0;
                I_pmax = 0;
                V_pmax = 0;
                data_T = 0;
                data_G = 0;
                data_Tc = 0;
                i_aux = 1;
                for i = t
                    % Truncado de datos
                    if app.ModoHora.Value == 1
                        Ta_aux = sum(app.Ta(i:i+60))/60;
                        G_Gh_aux = sum(app.G_Gh(i:i+60))/60;
                    else
                        Ta_aux = app.Ta(i);
                        G_Gh_aux = app.G_Gh(i);
                    end
                    % Aplicacin de prdidas por suciedad
                    G_Gh_aux = G_Gh_aux*(1 - app.PerSuc.Value/100);
                    % Temperatura de clula
                    Tc = 273.15 + Ta_aux + app.TONC*G_Gh_aux;
                    % Ejecucin de la simulacin de un punto
                    [I, V] = fast_diode(app.Voc, app.Isc, app.Ns, ...
                        app.Kv, app.Ki, app.Rs, app.Rp, G_Gh_aux, ...
                        Tc, str2double(app.Precision.Value), module_mode);
                    % Clculo de la potencia mxima y tension y corriente en Pmax
                    [I_aux, V_aux] = max_p_point(I, V);
                    V_aux = V_aux*app.ModulosSerie.Value;
                    I_aux = I_aux*app.ModulosParalelo.Value;
                    I_pmax(i_aux) = I_aux;
                    V_pmax(i_aux) = V_aux;
                    P(i_aux) = max(I.*V) * app.NumeroModulos.Value;
                    % Guardado de datos meteorolgicos truncados
                    data_T(i_aux) = Ta_aux;
                    data_G(i_aux) = G_Gh_aux;
                    data_Tc(i_aux) = Tc - 273.15;
                    % Avance de barra de progreso e ndice auxiliar
                    progressbar((1/length(t))*i_aux);
                    i_aux = i_aux + 1;
                end
                progressbar(1) % Cierre de barra de progreso
                
                % Aplicacin de prdidas a la potencia
                for i = 1:length(P)
                    P(i) = P(i)*(1 - app.PerFab.Value/100);
                    P(i) = P(i)*(1 - (app.PerVid.Value*0.8)/100);
                end
                
                % REPRESENTACIN DE DATOS GRFICOS
                t = 1:i_aux-1;
                plot(app.PotGraph, t, P); % Potencia Generada
                plot(app.TGraph, t, data_T); % Temp. ambiente
                plot(app.TcGraph, t, data_Tc); % Temp. de mdulo
                plot(app.GGraph, t, data_G); % Irradiancia
                plot(app.TensGraph, t, V_pmax); % Tensin Pmax
                plot(app.CorrGraph, t, I_pmax); % Corriente Pmax
                
                % CLCULO Y REPRESENTACIN DE DATOS NUMRICOS
                % Pot. acumulada
                pot_acumulada = sum(P)/pot_divider;
                i_aux = 0;
                while pot_acumulada > 1000 && i_aux < 5
                    pot_acumulada = pot_acumulada/1000;
                    i_aux = i_aux + 1;
                end
                app.PotenciaAcumulada.Value = pot_acumulada;
                switch i_aux
                    case 0;
                        app.PotenciaAcumuladaUnidad.Value = 'W';
                    case 1;
                        app.PotenciaAcumuladaUnidad.Value = 'kW';
                    case 2;
                        app.PotenciaAcumuladaUnidad.Value = 'gW';
                    case 3;
                        app.PotenciaAcumuladaUnidad.Value = 'tW';
                    case 4;
                        app.PotenciaAcumuladaUnidad.Value = 'pW';
                    case 5;
                        app.PotenciaAcumuladaUnidad.Value = 'eW';
                end
                % Rendimiento medio
                rend = sum(P)/(sum(data_G)*app.Sup)*100;
                app.RendAvg.Value = rend/app.NumeroModulos.Value;
                app.RendAvgUnidad.Value = '%';
                % Rendimiento mximo obtenido
                rend = P./(data_G*app.Sup);
                app.RendObt.Value = max(rend)*100/app.NumeroModulos.Value;
                app.RendObtUnidad.Value = '%';
                % Rendimiento STC dado por el fabricante
                [I, V] = fast_diode(app.Voc, app.Isc, app.Ns, app.Kv, app.Ki, ...
                    app.Rs, app.Rp, 1000, 298, 1000, module_mode);
                P_stc = I.*V;
                app.PotSTC.Value = max(P_stc);
                app.PotSTCUnidad.Value = 'W';
                rend = max(P_stc)/(1000*app.Sup)*100;
                app.RendSTC.Value = rend;
                app.RendSTCUnidad.Value = '%';
                % Voltaje mximo
                app.VoltMax.Value = max(V_pmax);
                app.VoltMaxUnidad.Value = 'V';
                % Intensidad mxima
                app.IntMax.Value = max(I_pmax);
                app.IntMaxUnidad.Value = 'A';
                % Voltaje e intensidad medias
                V_total = 0;
                I_total = 0;
                count = 0;
                for i = 1:length(V_pmax)
                    if V_pmax(i) > 0
                       V_total = V_total + V_pmax(i);
                       I_total = I_total + I_pmax(i);
                       count = count + 1;
                    end
                end
                app.VoltAvg.Value = V_total/count;
                app.VoltAvgUnidad.Value = 'V';
                app.IntAvg.Value = I_total/count;
                app.IntAvgUnidad.Value = 'A';
                % Representacin de curvas caractersticas
                % simuladas del mdulo
                plot(app.IVGraph, V, I);
                plot(app.PVGraph, V, P_stc);
                
                % Opcin de guardar datos en fichero
                quest = 'Deseas guardar los resultados en un fichero?';
                name = 'Guardar datos';
                respuesta = questdlg(quest, name, 'Si', 'No', 'No');
                if strcmp(respuesta, 'Si')
                    % Guardado en fichero
                    save_data(data_G, data_T, data_Tc, P, V_pmax, ...
                        I_pmax, n_month_start, n_day_start, ...
                        n_month_end, n_day_end, ...
                        app.ModulosSerie.Value, ...
                        app.ModulosParalelo.Value, ...
                        app.NumeroModulos.Value);
                    prompt = 'Datos guardados!';
                    name = 'Atencion';
                else
                    prompt = 'Datos no guardados!';
                    name = 'Atencion';
                end
                % Mensaje con el resultado de la operacin
                warndlg(prompt, name);
            end
        end

        % ListaData value changed function
        function ListaDataValueChanged(app)
            % Deteccin del fichero seleccionado
            data_to_read = app.ListaData.Value;
            % Busca ndice en la lista de ficheros cargados
            index_mat = strfind(app.DataFileNames, data_to_read);
            for i = 1:length(index_mat)
                if (index_mat{i} == 1)
                    index_aux = i;
                    break;
                end
            end
            % Generacin ruta del fichero
            data_filename = strcat(app.DataFilePaths{index_aux}, ...
                app.DataFileNames{index_aux});
            % Carga del fichero en memoria
            [app.G_Gh, app.Ta] = meteonorm_file(data_filename);
        end

        % ListaModulos value changed function
        function ListaModulosValueChanged(app)
            % Deteccin del mdulo a usar
            module_to_read = app.ListaModulos.Value;
            % Busca ndice en la lista de ficheros cargados
            index_mat = strfind(app.ModuleFileNames, module_to_read);
            for i = 1:length(index_mat)
                if (index_mat{i} == 1)
                    index_aux = i;
                    break;
                end
            end
            % Generacin ruta del fichero
            module_filename = strcat(app.ModuleFilePaths{index_aux}, ...
                app.ModuleFileNames{index_aux});
            % Carga del fichero en memoria
            [app.ModuleName, app.Rend, app.Voc, app.Isc, app.Pmp, app.Imp, ...
                app.Vmp, app.Ns, app.Kv, app.Ki, app.Rs, app.Rp, ...
                app.TONC, app.Sup] = read_modulefile(module_filename);
            disp(app.ModuleName);
            % Visualizacin de los datos en memoria
            app.ModeloModulo.Value = app.ModuleName;
            app.ModuloRend.Value = app.Rend;
            app.ModuloVoc.Value = app.Voc;
            app.ModuloIsc.Value = app.Isc;
            app.ModuloPmp.Value = app.Pmp;
            app.ModuloImp.Value = app.Imp;
            app.ModuloVmp.Value = app.Vmp;
            app.ModuloNs.Value = app.Ns;
            app.ModuloKv.Value = app.Kv;
            app.ModuloKi.Value = app.Ki;
            app.ModuloSup.Value = app.Sup;
        end

        % ComienzoMes value changed function
        function ComienzoMesValueChanged(app, event)
            % Obtencin del nmero de mes
            n_month = get_month_num(app.ComienzoMes.Value);
            % Obtencin del n de das del mes
            n_days = get_days_month(n_month);
            % Creacin de la lista de das
            day_list = cell(0);
            for i = 1:n_days
                day_list{i} = num2str(i);
            end
            % Guardado de la lista de das, seleccin del primero
            app.ComienzoDia.Items = day_list;
            app.ComienzoDia.Value = app.ComienzoDia.Items{1};
        end

        % FinalMes value changed function
        function FinalMesValueChanged(app, event)
            % Obtencin del nmero de mes
            n_month = get_month_num(app.FinalMes.Value);
            % Obtencin del n de das del mes
            n_days = get_days_month(n_month);
            % Creacin de la lista de das
            day_list = cell(0);
            for i = 1:n_days
                day_list{i} = num2str(i);
            end
            % Guardado de la lista de das, seleccin del primero
            app.FinalDia.Items = day_list;
            app.FinalDia.Value = app.FinalDia.Items{1};
        end

        % FileFuser button pushed function
        function FileFuserButtonPushed(app)
            % Ejecucin de la utilidad "file_fuser"
            file_fuser();
        end

        % CalcRes1 button pushed function
        function CalcRes1ButtonPushed(app)
            % Generacin de ventana de peticin de datos
            prompt = {'Voc:', 'Isc:', 'Vmp::', 'Imp:', 'Ns', ...
                'Kv:', 'Ki:'};
            dlg_title = 'Valores mdulo';
            num_lines = 1;
            defaultans = {'46.2', '9.48', '37.9', '8.97', '72', ...
                '-143', '5.02'};
            values = inputdlg(prompt,dlg_title,num_lines,defaultans);
            % Guardado de datos en memoria
            Voc_aux = str2double(values{1});
            Isc_aux = str2double(values{2});
            Vmp_aux = str2double(values{3});
            Imp_aux = str2double(values{4});
            Ns_aux = str2double(values{5});
            Kv_aux = str2double(values{6});
            Ki_aux = str2double(values{7});
            % Ejecucin del script de clculo de resistencias
            fast_1_diode_resget(Voc_aux, Isc_aux, Vmp_aux, Imp_aux, ...
                Ns_aux, Kv_aux, Ki_aux);
        end

        % CalcRes2 button pushed function
        function CalcRes2ButtonPushed(app)
             % Generacin de ventana de peticin de datos
            prompt = {'Voc:', 'Isc:', 'Vmp::', 'Imp:', 'Ns', 'Kv:', ...
                'Ki:'};
            dlg_title = 'Valores mdulo';
            num_lines = 1;
            defaultans = {'46.2', '9.48', '37.9', '8.97', '72', ...
                '-143', '5.02'};
            values = inputdlg(prompt,dlg_title,num_lines,defaultans);
            % Guardado de datos en memoria
            Voc_aux = str2double(values{1});
            Isc_aux = str2double(values{2});
            Vmp_aux = str2double(values{3});
            Imp_aux = str2double(values{4});
            Ns_aux = str2double(values{5});
            Kv_aux = str2double(values{6});
            Ki_aux = str2double(values{7});
            % Ejecucin del script de clculo de resistencias
            fast_2_diode_resget(Voc_aux, Isc_aux, Vmp_aux, Imp_aux, ...
                Ns_aux, Kv_aux, Ki_aux);
        end

        % PerFabRand value changed function
        function PerFabRandValueChanged(app)
            % Generacin de valor aletorio para
            % prdidas de potencia de fbrica
            value = app.PerFabRand.Value;
            if value == true
                app.PerFab.Editable = 'off';
                app.PerFab.Value = round((10*rand(1, 1, ...
                    'double'))*100)/100;
            else
                app.PerFab.Editable = 'on';
            end
        end

        % PerVidRand value changed function
        function PerVidRandValueChanged(app)
            % Generacin de valor aletorio para
            % prdidas de potencia de ciclo de vida
            value = app.PerVidRand.Value;
            if value == true
                app.PerVid.Editable = 'off';
                app.PerVid.Value = randi(25);
            else
                app.PerVid.Editable = 'on';
            end
        end

        % PerSucRand value changed function
        function PerSucRandValueChanged(app)
            % Generacin de valor aletorio para
            % prdidas de irradiancia por suciedad
            value = app.PerSucRand.Value;
            if value == true
                app.PerSuc.Editable = 'off';
                app.PerSuc.Value = round((100*rand(1, 1, ...
                    'double'))*100)/100;
            else
                app.PerSuc.Editable = 'on';
            end
        end

        % ModulosSerie value changed function
        function ModulosSerieValueChanged(app)
            app.NumeroModulos.Value = app.ModulosSerie.Value *...
                app.ModulosParalelo.Value *...
                app.MultiplicadorModulos.Value;
        end

        % ModulosParalelo value changed function
        function ModulosParaleloValueChanged(app)
            app.NumeroModulos.Value = app.ModulosSerie.Value *...
                app.ModulosParalelo.Value *...
                app.MultiplicadorModulos.Value;
        end

        % MultiplicadorModulos value changed function
        function MultiplicadorModulosValueChanged(app)
            app.NumeroModulos.Value = app.ModulosSerie.Value *...
                app.ModulosParalelo.Value *...
                app.MultiplicadorModulos.Value;
        end
    end

    % App initialization and construction
    methods (Access = private)

        % Create UIFigure and components
        function createComponents(app)

            % Create PreciSolApp
            app.PreciSolApp = uifigure;
            app.PreciSolApp.Position = [100 100 1280 720];
            app.PreciSolApp.Name = 'PreciSol';
            setAutoResize(app, app.PreciSolApp, true)

            % Create Graficas
            app.Graficas = uitabgroup(app.PreciSolApp);
            app.Graficas.Units = 'pixels';
            app.Graficas.Position = [432 12 835 680];

            % Create IV
            app.IV = uitab(app.Graficas);
            app.IV.Units = 'pixels';
            app.IV.Title = 'I-V';

            % Create IVGraph
            app.IVGraph = uiaxes(app.IV);
            title(app.IVGraph, 'Corriente-Tensin (V-A)');
            xlabel(app.IVGraph, 'V');
            ylabel(app.IVGraph, 'I');
            app.IVGraph.Position = [1 2 833 656];

            % Create PV
            app.PV = uitab(app.Graficas);
            app.PV.Units = 'pixels';
            app.PV.Title = 'P-V';

            % Create PVGraph
            app.PVGraph = uiaxes(app.PV);
            title(app.PVGraph, 'Potencia (W)');
            xlabel(app.PVGraph, 'P');
            ylabel(app.PVGraph, 'I');
            app.PVGraph.Position = [1 2 833 656];

            % Create T
            app.T = uitab(app.Graficas);
            app.T.Units = 'pixels';
            app.T.Title = 'T';

            % Create TGraph
            app.TGraph = uiaxes(app.T);
            title(app.TGraph, 'Temperatura (C)');
            xlabel(app.TGraph, 't');
            ylabel(app.TGraph, 'T');
            app.TGraph.Position = [1 2 833 656];

            % Create G
            app.G = uitab(app.Graficas);
            app.G.Units = 'pixels';
            app.G.Title = 'G';

            % Create GGraph
            app.GGraph = uiaxes(app.G);
            title(app.GGraph, 'Irradiancia (W/m2)');
            xlabel(app.GGraph, 't');
            ylabel(app.GGraph, 'G');
            app.GGraph.Position = [1 2 833 656];

            % Create Pot
            app.Pot = uitab(app.Graficas);
            app.Pot.Units = 'pixels';
            app.Pot.Title = 'Potencia Generada';

            % Create PotGraph
            app.PotGraph = uiaxes(app.Pot);
            title(app.PotGraph, 'Potencia generada (W/t)');
            xlabel(app.PotGraph, 't');
            ylabel(app.PotGraph, 'P');
            app.PotGraph.Position = [1 1 833 657];

            % Create Datos
            app.Datos = uitab(app.Graficas);
            app.Datos.Units = 'pixels';
            app.Datos.Title = 'Datos';

            % Create LabelNumericEditField2
            app.LabelNumericEditField2 = uilabel(app.Datos);
            app.LabelNumericEditField2.HorizontalAlignment = 'right';
            app.LabelNumericEditField2.FontSize = 36;
            app.LabelNumericEditField2.Position = [10 594 327 47];
            app.LabelNumericEditField2.Text = 'Potencia acumulada';

            % Create PotenciaAcumulada
            app.PotenciaAcumulada = uieditfield(app.Datos, 'numeric');
            app.PotenciaAcumulada.ValueDisplayFormat = '%11.6g';
            app.PotenciaAcumulada.Editable = 'off';
            app.PotenciaAcumulada.FontSize = 48;
            app.PotenciaAcumulada.Position = [344 587 190 57];

            % Create PotenciaAcumuladaUnidad
            app.PotenciaAcumuladaUnidad = uieditfield(app.Datos, 'text');
            app.PotenciaAcumuladaUnidad.Editable = 'off';
            app.PotenciaAcumuladaUnidad.FontSize = 48;
            app.PotenciaAcumuladaUnidad.Position = [550 588 119 55];

            % Create RendSTCUnidad
            app.RendSTCUnidad = uieditfield(app.Datos, 'text');
            app.RendSTCUnidad.Editable = 'off';
            app.RendSTCUnidad.FontSize = 48;
            app.RendSTCUnidad.Position = [550 517 119 55];

            % Create Label4
            app.Label4 = uilabel(app.Datos);
            app.Label4.HorizontalAlignment = 'right';
            app.Label4.FontSize = 36;
            app.Label4.Position = [52 523 285 47];
            app.Label4.Text = 'Rendimiento STC';

            % Create RendSTC
            app.RendSTC = uieditfield(app.Datos, 'numeric');
            app.RendSTC.ValueDisplayFormat = '%11.6g';
            app.RendSTC.Editable = 'off';
            app.RendSTC.FontSize = 48;
            app.RendSTC.Position = [344 516 190 57];

            % Create RendObtUnidad
            app.RendObtUnidad = uieditfield(app.Datos, 'text');
            app.RendObtUnidad.Editable = 'off';
            app.RendObtUnidad.FontSize = 48;
            app.RendObtUnidad.Position = [550 445 119 55];

            % Create Label5
            app.Label5 = uilabel(app.Datos);
            app.Label5.HorizontalAlignment = 'right';
            app.Label5.FontSize = 36;
            app.Label5.Position = [4 451 333 47];
            app.Label5.Text = 'Rend. max. obtenido';

            % Create RendObt
            app.RendObt = uieditfield(app.Datos, 'numeric');
            app.RendObt.ValueDisplayFormat = '%11.6g';
            app.RendObt.Editable = 'off';
            app.RendObt.FontSize = 48;
            app.RendObt.Position = [344 444 190 57];

            % Create RendAvgUnidad
            app.RendAvgUnidad = uieditfield(app.Datos, 'text');
            app.RendAvgUnidad.Editable = 'off';
            app.RendAvgUnidad.FontSize = 48;
            app.RendAvgUnidad.Position = [550 375 119 55];

            % Create Label6
            app.Label6 = uilabel(app.Datos);
            app.Label6.HorizontalAlignment = 'right';
            app.Label6.FontSize = 36;
            app.Label6.Position = [26 381 311 47];
            app.Label6.Text = 'Rendimiento medio';

            % Create RendAvg
            app.RendAvg = uieditfield(app.Datos, 'numeric');
            app.RendAvg.ValueDisplayFormat = '%11.6g';
            app.RendAvg.Editable = 'off';
            app.RendAvg.FontSize = 48;
            app.RendAvg.Position = [344 374 190 57];

            % Create PotSTCUnidad
            app.PotSTCUnidad = uieditfield(app.Datos, 'text');
            app.PotSTCUnidad.Editable = 'off';
            app.PotSTCUnidad.FontSize = 48;
            app.PotSTCUnidad.Position = [551 304 119 55];

            % Create Label22
            app.Label22 = uilabel(app.Datos);
            app.Label22.HorizontalAlignment = 'right';
            app.Label22.FontSize = 36;
            app.Label22.Position = [115 310 223 47];
            app.Label22.Text = 'Potencia STC';

            % Create PotSTC
            app.PotSTC = uieditfield(app.Datos, 'numeric');
            app.PotSTC.ValueDisplayFormat = '%11.6g';
            app.PotSTC.Editable = 'off';
            app.PotSTC.FontSize = 48;
            app.PotSTC.Position = [345 303 190 57];

            % Create Label28
            app.Label28 = uilabel(app.Datos);
            app.Label28.HorizontalAlignment = 'right';
            app.Label28.FontSize = 36;
            app.Label28.Position = [91 238 247 47];
            app.Label28.Text = 'Voltaje mximo';

            % Create VoltMax
            app.VoltMax = uieditfield(app.Datos, 'numeric');
            app.VoltMax.ValueDisplayFormat = '%11.6g';
            app.VoltMax.Editable = 'off';
            app.VoltMax.FontSize = 48;
            app.VoltMax.Position = [345 231 190 57];

            % Create Label29
            app.Label29 = uilabel(app.Datos);
            app.Label29.HorizontalAlignment = 'right';
            app.Label29.FontSize = 36;
            app.Label29.Position = [53 96 285 47];
            app.Label29.Text = 'Corriente mxima';

            % Create IntMax
            app.IntMax = uieditfield(app.Datos, 'numeric');
            app.IntMax.ValueDisplayFormat = '%11.6g';
            app.IntMax.Editable = 'off';
            app.IntMax.FontSize = 48;
            app.IntMax.Position = [345 89 190 57];

            % Create Label30
            app.Label30 = uilabel(app.Datos);
            app.Label30.HorizontalAlignment = 'right';
            app.Label30.FontSize = 36;
            app.Label30.Position = [119 166 219 47];
            app.Label30.Text = 'Voltaje medio';

            % Create VoltAvg
            app.VoltAvg = uieditfield(app.Datos, 'numeric');
            app.VoltAvg.ValueDisplayFormat = '%11.6g';
            app.VoltAvg.Editable = 'off';
            app.VoltAvg.FontSize = 48;
            app.VoltAvg.Position = [345 159 190 57];

            % Create Label31
            app.Label31 = uilabel(app.Datos);
            app.Label31.HorizontalAlignment = 'right';
            app.Label31.FontSize = 36;
            app.Label31.Position = [81 26 257 47];
            app.Label31.Text = 'Corriente media';

            % Create IntAvg
            app.IntAvg = uieditfield(app.Datos, 'numeric');
            app.IntAvg.ValueDisplayFormat = '%11.6g';
            app.IntAvg.Editable = 'off';
            app.IntAvg.FontSize = 48;
            app.IntAvg.Position = [345 19 190 57];

            % Create VoltMaxUnidad
            app.VoltMaxUnidad = uieditfield(app.Datos, 'text');
            app.VoltMaxUnidad.Editable = 'off';
            app.VoltMaxUnidad.FontSize = 48;
            app.VoltMaxUnidad.Position = [551 233 119 55];

            % Create VoltAvgUnidad
            app.VoltAvgUnidad = uieditfield(app.Datos, 'text');
            app.VoltAvgUnidad.Editable = 'off';
            app.VoltAvgUnidad.FontSize = 48;
            app.VoltAvgUnidad.Position = [551 159 119 55];

            % Create IntMaxUnidad
            app.IntMaxUnidad = uieditfield(app.Datos, 'text');
            app.IntMaxUnidad.Editable = 'off';
            app.IntMaxUnidad.FontSize = 48;
            app.IntMaxUnidad.Position = [550 90 119 55];

            % Create IntAvgUnidad
            app.IntAvgUnidad = uieditfield(app.Datos, 'text');
            app.IntAvgUnidad.Editable = 'off';
            app.IntAvgUnidad.FontSize = 48;
            app.IntAvgUnidad.Position = [551 19 119 55];

            % Create Utilidades
            app.Utilidades = uitab(app.Graficas);
            app.Utilidades.Units = 'pixels';
            app.Utilidades.Title = 'Utilidades';

            % Create Label20
            app.Label20 = uilabel(app.Utilidades);
            app.Label20.Position = [27 621 50 15];
            app.Label20.Text = 'File fuser';

            % Create FileFuser
            app.FileFuser = uibutton(app.Utilidades, 'push');
            app.FileFuser.ButtonPushedFcn = createCallbackFcn(app, @FileFuserButtonPushed);
            app.FileFuser.Position = [27 587 100 22];
            app.FileFuser.Text = 'Fusionar ficheros';

            % Create Label23
            app.Label23 = uilabel(app.Utilidades);
            app.Label23.Position = [27 558 174 15];
            app.Label23.Text = 'Calculador resistencias Rs y Rp';

            % Create CalcRes1
            app.CalcRes1 = uibutton(app.Utilidades, 'push');
            app.CalcRes1.ButtonPushedFcn = createCallbackFcn(app, @CalcRes1ButtonPushed);
            app.CalcRes1.Position = [27 524 100 22];
            app.CalcRes1.Text = '1 diodo';

            % Create CalcRes2
            app.CalcRes2 = uibutton(app.Utilidades, 'push');
            app.CalcRes2.ButtonPushedFcn = createCallbackFcn(app, @CalcRes2ButtonPushed);
            app.CalcRes2.Position = [141 524 100 22];
            app.CalcRes2.Text = '2 diodos';

            % Create TempModulo
            app.TempModulo = uitab(app.Graficas);
            app.TempModulo.Units = 'pixels';
            app.TempModulo.Title = 'Tc';

            % Create TcGraph
            app.TcGraph = uiaxes(app.TempModulo);
            title(app.TcGraph, 'Temperatura (C)');
            xlabel(app.TcGraph, 't');
            ylabel(app.TcGraph, 'T');
            app.TcGraph.Position = [1 2 833 656];

            % Create TensionPmax
            app.TensionPmax = uitab(app.Graficas);
            app.TensionPmax.Units = 'pixels';
            app.TensionPmax.Title = 'V';

            % Create TensGraph
            app.TensGraph = uiaxes(app.TensionPmax);
            title(app.TensGraph, 'Tensin (V)');
            xlabel(app.TensGraph, 't');
            ylabel(app.TensGraph, 'V');
            app.TensGraph.Position = [1 2 833 656];

            % Create CorrientePmax
            app.CorrientePmax = uitab(app.Graficas);
            app.CorrientePmax.Units = 'pixels';
            app.CorrientePmax.Title = 'I';

            % Create CorrGraph
            app.CorrGraph = uiaxes(app.CorrientePmax);
            title(app.CorrGraph, 'Corriente (A)');
            xlabel(app.CorrGraph, 't');
            ylabel(app.CorrGraph, 'A');
            app.CorrGraph.Position = [1 2 833 656];

            % Create Simular
            app.Simular = uibutton(app.PreciSolApp, 'push');
            app.Simular.ButtonPushedFcn = createCallbackFcn(app, @SimularButtonPushed);
            app.Simular.FontSize = 20;
            app.Simular.Position = [108 9 212 41];
            app.Simular.Text = 'Simular';

            % Create Label
            app.Label = uilabel(app.PreciSolApp);
            app.Label.FontSize = 36;
            app.Label.Position = [14 646 405 58];
            app.Label.Text = 'Simulador de clula solar';

            % Create MeteoData
            app.MeteoData = uipanel(app.PreciSolApp);
            app.MeteoData.BorderType = 'line';
            app.MeteoData.Title = 'Datos meteorolgicos';
            app.MeteoData.FontName = 'Helvetica';
            app.MeteoData.FontUnits = 'pixels';
            app.MeteoData.FontSize = 12;
            app.MeteoData.Units = 'pixels';
            app.MeteoData.Position = [14 205 405 191];

            % Create CargarData
            app.CargarData = uibutton(app.MeteoData, 'push');
            app.CargarData.ButtonPushedFcn = createCallbackFcn(app, @CargarDataButtonPushed);
            app.CargarData.Position = [294 134 100 22];
            app.CargarData.Text = 'Cargar';

            % Create EliminarData
            app.EliminarData = uibutton(app.MeteoData, 'push');
            app.EliminarData.ButtonPushedFcn = createCallbackFcn(app, @EliminarDataButtonPushed);
            app.EliminarData.Position = [294 95 100 22];
            app.EliminarData.Text = 'Eliminar';

            % Create LabelListBox2
            app.LabelListBox2 = uilabel(app.MeteoData);
            app.LabelListBox2.HorizontalAlignment = 'right';
            app.LabelListBox2.Position = [8 141 47 15];
            app.LabelListBox2.Text = 'Archivos';

            % Create ListaData
            app.ListaData = uilistbox(app.MeteoData);
            app.ListaData.Items = {};
            app.ListaData.ValueChangedFcn = createCallbackFcn(app, @ListaDataValueChanged);
            app.ListaData.Position = [71 84 191 74];
            app.ListaData.Value = {};

            % Create LabelDropDown2
            app.LabelDropDown2 = uilabel(app.MeteoData);
            app.LabelDropDown2.HorizontalAlignment = 'right';
            app.LabelDropDown2.Position = [73 58 23 15];
            app.LabelDropDown2.Text = 'Mes';

            % Create ComienzoMes
            app.ComienzoMes = uidropdown(app.MeteoData);
            app.ComienzoMes.Items = {'Enero', 'Febrero', 'Marzo', 'Abril', 'Mayo', 'Junio', 'Julio', 'Agosto', 'Septiembre', 'Octubre', 'Noviembre', 'Diciembre'};
            app.ComienzoMes.ValueChangedFcn = createCallbackFcn(app, @ComienzoMesValueChanged, true);
            app.ComienzoMes.Position = [111 54 86 22];
            app.ComienzoMes.Value = 'Enero';

            % Create Label3
            app.Label3 = uilabel(app.MeteoData);
            app.Label3.HorizontalAlignment = 'right';
            app.Label3.Position = [206 58 20 15];
            app.Label3.Text = 'Da';

            % Create ComienzoDia
            app.ComienzoDia = uidropdown(app.MeteoData);
            app.ComienzoDia.Items = {'1', '2', '3', '4', '5', '6', '7', '8', '9', '10', '11', '12', '13', '14', '15', '16', '17', '18', '19', '20', '21', '22', '23', '24', '25', '26', '27', '28', '29', '30', '31'};
            app.ComienzoDia.Position = [241 54 44 22];
            app.ComienzoDia.Value = '1';

            % Create FechaMode
            app.FechaMode = uibuttongroup(app.MeteoData);
            app.FechaMode.BorderType = 'line';
            app.FechaMode.Title = 'Modo';
            app.FechaMode.FontName = 'Helvetica';
            app.FechaMode.FontUnits = 'pixels';
            app.FechaMode.FontSize = 12;
            app.FechaMode.Units = 'pixels';
            app.FechaMode.Position = [297 12 93 71];

            % Create ModoHora
            app.ModoHora = uiradiobutton(app.FechaMode);
            app.ModoHora.Text = 'Hora';
            app.ModoHora.Position = [9 26 46 16];
            app.ModoHora.Value = true;

            % Create ModoMinuto
            app.ModoMinuto = uiradiobutton(app.FechaMode);
            app.ModoMinuto.Text = 'Minuto';
            app.ModoMinuto.Position = [9 3 56 16];

            % Create Label16
            app.Label16 = uilabel(app.MeteoData);
            app.Label16.HorizontalAlignment = 'right';
            app.Label16.Position = [73 22 23 15];
            app.Label16.Text = 'Mes';

            % Create FinalMes
            app.FinalMes = uidropdown(app.MeteoData);
            app.FinalMes.Items = {'Enero', 'Febrero', 'Marzo', 'Abril', 'Mayo', 'Junio', 'Julio', 'Agosto', 'Septiembre', 'Octubre', 'Noviembre', 'Diciembre'};
            app.FinalMes.ValueChangedFcn = createCallbackFcn(app, @FinalMesValueChanged, true);
            app.FinalMes.Position = [111 18 86 22];
            app.FinalMes.Value = 'Enero';

            % Create Label17
            app.Label17 = uilabel(app.MeteoData);
            app.Label17.HorizontalAlignment = 'right';
            app.Label17.Position = [206 22 20 15];
            app.Label17.Text = 'Da';

            % Create FinalDia
            app.FinalDia = uidropdown(app.MeteoData);
            app.FinalDia.Items = {'1', '2', '3', '4', '5', '6', '7', '8', '9', '10', '11', '12', '13', '14', '15', '16', '17', '18', '19', '20', '21', '22', '23', '24', '25', '26', '27', '28', '29', '30', '31'};
            app.FinalDia.Position = [241 18 44 22];
            app.FinalDia.Value = '1';

            % Create Label18
            app.Label18 = uilabel(app.MeteoData);
            app.Label18.Position = [6 58 56 15];
            app.Label18.Text = 'Comienzo';

            % Create Label19
            app.Label19 = uilabel(app.MeteoData);
            app.Label19.Position = [6 22 27 15];
            app.Label19.Text = 'Final';

            % Create Modulos
            app.Modulos = uipanel(app.PreciSolApp);
            app.Modulos.BorderType = 'line';
            app.Modulos.Title = 'Mdulos';
            app.Modulos.FontName = 'Helvetica';
            app.Modulos.FontUnits = 'pixels';
            app.Modulos.FontSize = 12;
            app.Modulos.Units = 'pixels';
            app.Modulos.Position = [13 403 405 229];

            % Create CargarModulos
            app.CargarModulos = uibutton(app.Modulos, 'push');
            app.CargarModulos.ButtonPushedFcn = createCallbackFcn(app, @CargarModulosButtonPushed);
            app.CargarModulos.Position = [294 172 100 22];
            app.CargarModulos.Text = 'Cargar';

            % Create EliminarModulos
            app.EliminarModulos = uibutton(app.Modulos, 'push');
            app.EliminarModulos.ButtonPushedFcn = createCallbackFcn(app, @EliminarModulosButtonPushed);
            app.EliminarModulos.Position = [294 133 100 22];
            app.EliminarModulos.Text = 'Eliminar';

            % Create Label2
            app.Label2 = uilabel(app.Modulos);
            app.Label2.HorizontalAlignment = 'right';
            app.Label2.Position = [25 179 30 15];
            app.Label2.Text = 'Tipos';

            % Create ListaModulos
            app.ListaModulos = uilistbox(app.Modulos);
            app.ListaModulos.Items = {};
            app.ListaModulos.ValueChangedFcn = createCallbackFcn(app, @ListaModulosValueChanged);
            app.ListaModulos.Position = [71 122 191 74];
            app.ListaModulos.Value = {};

            % Create ModeloModulo
            app.ModeloModulo = uieditfield(app.Modulos, 'text');
            app.ModeloModulo.Editable = 'off';
            app.ModeloModulo.Position = [6 91 379 22];

            % Create LabelNumericEditField4
            app.LabelNumericEditField4 = uilabel(app.Modulos);
            app.LabelNumericEditField4.HorizontalAlignment = 'right';
            app.LabelNumericEditField4.Position = [15 68 40 15];
            app.LabelNumericEditField4.Text = 'Voc (V)';

            % Create ModuloVoc
            app.ModuloVoc = uieditfield(app.Modulos, 'numeric');
            app.ModuloVoc.Editable = 'off';
            app.ModuloVoc.Position = [56 64 47 22];

            % Create Label7
            app.Label7 = uilabel(app.Modulos);
            app.Label7.HorizontalAlignment = 'right';
            app.Label7.Position = [21 42 34 15];
            app.Label7.Text = 'Isc (A)';

            % Create ModuloIsc
            app.ModuloIsc = uieditfield(app.Modulos, 'numeric');
            app.ModuloIsc.Editable = 'off';
            app.ModuloIsc.Position = [56 38 47 22];

            % Create Label8
            app.Label8 = uilabel(app.Modulos);
            app.Label8.HorizontalAlignment = 'right';
            app.Label8.Position = [112 68 20 15];
            app.Label8.Text = 'Ki';

            % Create ModuloKi
            app.ModuloKi = uieditfield(app.Modulos, 'numeric');
            app.ModuloKi.Editable = 'off';
            app.ModuloKi.Position = [147 64 47 22];

            % Create Label9
            app.Label9 = uilabel(app.Modulos);
            app.Label9.HorizontalAlignment = 'right';
            app.Label9.Position = [112 42 20 15];
            app.Label9.Text = 'Kv';

            % Create ModuloKv
            app.ModuloKv = uieditfield(app.Modulos, 'numeric');
            app.ModuloKv.Editable = 'off';
            app.ModuloKv.Position = [147 38 47 22];

            % Create Label10
            app.Label10 = uilabel(app.Modulos);
            app.Label10.HorizontalAlignment = 'right';
            app.Label10.Position = [218 40 20 15];
            app.Label10.Text = 'Ns';

            % Create ModuloNs
            app.ModuloNs = uieditfield(app.Modulos, 'numeric');
            app.ModuloNs.Editable = 'off';
            app.ModuloNs.Position = [241 36 47 22];

            % Create Label11
            app.Label11 = uilabel(app.Modulos);
            app.Label11.HorizontalAlignment = 'right';
            app.Label11.Position = [203 14 34 15];
            app.Label11.Text = 'TONC';

            % Create ModuloTONC
            app.ModuloTONC = uieditfield(app.Modulos, 'numeric');
            app.ModuloTONC.Editable = 'off';
            app.ModuloTONC.Position = [241 10 47 22];

            % Create Label12
            app.Label12 = uilabel(app.Modulos);
            app.Label12.HorizontalAlignment = 'right';
            app.Label12.Position = [297 40 25 15];
            app.Label12.Text = 'Vmp';

            % Create ModuloVmp
            app.ModuloVmp = uieditfield(app.Modulos, 'numeric');
            app.ModuloVmp.Editable = 'off';
            app.ModuloVmp.Position = [337 36 47 22];

            % Create Label13
            app.Label13 = uilabel(app.Modulos);
            app.Label13.HorizontalAlignment = 'right';
            app.Label13.Position = [302 14 20 15];
            app.Label13.Text = 'Imp';

            % Create ModuloImp
            app.ModuloImp = uieditfield(app.Modulos, 'numeric');
            app.ModuloImp.Editable = 'off';
            app.ModuloImp.Position = [337 10 47 22];

            % Create Label14
            app.Label14 = uilabel(app.Modulos);
            app.Label14.HorizontalAlignment = 'right';
            app.Label14.Position = [206 68 29 15];
            app.Label14.Text = '? (%)';

            % Create ModuloRend
            app.ModuloRend = uieditfield(app.Modulos, 'numeric');
            app.ModuloRend.Editable = 'off';
            app.ModuloRend.Position = [240 64 47 22];

            % Create Label15
            app.Label15 = uilabel(app.Modulos);
            app.Label15.HorizontalAlignment = 'right';
            app.Label15.Position = [298 67 25 15];
            app.Label15.Text = 'Pmp';

            % Create ModuloPmp
            app.ModuloPmp = uieditfield(app.Modulos, 'numeric');
            app.ModuloPmp.Editable = 'off';
            app.ModuloPmp.Position = [338 63 47 22];

            % Create Label21
            app.Label21 = uilabel(app.Modulos);
            app.Label21.HorizontalAlignment = 'right';
            app.Label21.Position = [54 15 89 15];
            app.Label21.Text = 'Superficie (m^2)';

            % Create ModuloSup
            app.ModuloSup = uieditfield(app.Modulos, 'numeric');
            app.ModuloSup.Editable = 'off';
            app.ModuloSup.Position = [147 11 47 22];

            % Create DatosSimulacion
            app.DatosSimulacion = uitabgroup(app.PreciSolApp);
            app.DatosSimulacion.Units = 'pixels';
            app.DatosSimulacion.Position = [14 58 404 139];

            % Create DatosBasicos
            app.DatosBasicos = uitab(app.DatosSimulacion);
            app.DatosBasicos.Units = 'pixels';
            app.DatosBasicos.Title = 'Simulacin';

            % Create LabelDiscreteKnob
            app.LabelDiscreteKnob = uilabel(app.DatosBasicos);
            app.LabelDiscreteKnob.HorizontalAlignment = 'center';
            app.LabelDiscreteKnob.Position = [191.5 91 51 15];
            app.LabelDiscreteKnob.Text = 'Precisin';

            % Create Precision
            app.Precision = uiknob(app.DatosBasicos, 'discrete');
            app.Precision.Items = {'10', '100', '1000', '10000', '100000'};
            app.Precision.Position = [267 7 69 69];
            app.Precision.Value = '1000';

            % Create Modelo
            app.Modelo = uibuttongroup(app.DatosBasicos);
            app.Modelo.BorderType = 'line';
            app.Modelo.Title = 'Modelo de simulacin';
            app.Modelo.FontName = 'Helvetica';
            app.Modelo.FontUnits = 'pixels';
            app.Modelo.FontSize = 12;
            app.Modelo.Units = 'pixels';
            app.Modelo.Position = [20 19 143 74];

            % Create Diodo1Modelo
            app.Diodo1Modelo = uiradiobutton(app.Modelo);
            app.Diodo1Modelo.Text = 'Modelo de 1 diodo';
            app.Diodo1Modelo.Position = [10 27 121 16];
            app.Diodo1Modelo.Value = true;

            % Create Diodo2Modelo
            app.Diodo2Modelo = uiradiobutton(app.Modelo);
            app.Diodo2Modelo.Text = 'Modelo de 2 diodos';
            app.Diodo2Modelo.Position = [10 5 127 16];

            % Create DatosPerdidas
            app.DatosPerdidas = uitab(app.DatosSimulacion);
            app.DatosPerdidas.Units = 'pixels';
            app.DatosPerdidas.Title = 'Prdidas';

            % Create LabelNumericEditField5
            app.LabelNumericEditField5 = uilabel(app.DatosPerdidas);
            app.LabelNumericEditField5.HorizontalAlignment = 'right';
            app.LabelNumericEditField5.Position = [37 71 192 15];
            app.LabelNumericEditField5.Text = 'Prdida de pot. nom. de fbrica (%)';

            % Create PerFab
            app.PerFab = uieditfield(app.DatosPerdidas, 'numeric');
            app.PerFab.Limits = [0 10];
            app.PerFab.Position = [244 67 46 22];

            % Create Label24
            app.Label24 = uilabel(app.DatosPerdidas);
            app.Label24.HorizontalAlignment = 'right';
            app.Label24.Position = [42 42 187 15];
            app.Label24.Text = 'Prdida de pot. por vida til (aos)';

            % Create PerVid
            app.PerVid = uieditfield(app.DatosPerdidas, 'numeric');
            app.PerVid.Limits = [0 25];
            app.PerVid.Position = [244 38 46 22];

            % Create Label25
            app.Label25 = uilabel(app.DatosPerdidas);
            app.Label25.HorizontalAlignment = 'right';
            app.Label25.Position = [12 13 217 15];
            app.Label25.Text = 'Prdida de irradiancia por suciedad (%)';

            % Create PerSuc
            app.PerSuc = uieditfield(app.DatosPerdidas, 'numeric');
            app.PerSuc.Limits = [0 100];
            app.PerSuc.Position = [244 9 46 22];

            % Create Label26
            app.Label26 = uilabel(app.DatosPerdidas);
            app.Label26.Position = [306 95 62 15];
            app.Label26.Text = 'Estocstico';

            % Create PerFabRand
            app.PerFabRand = uicheckbox(app.DatosPerdidas);
            app.PerFabRand.ValueChangedFcn = createCallbackFcn(app, @PerFabRandValueChanged);
            app.PerFabRand.Text = '';
            app.PerFabRand.Position = [328 70 22 16];

            % Create PerVidRand
            app.PerVidRand = uicheckbox(app.DatosPerdidas);
            app.PerVidRand.ValueChangedFcn = createCallbackFcn(app, @PerVidRandValueChanged);
            app.PerVidRand.Text = '';
            app.PerVidRand.Position = [328 41 22 16];

            % Create PerSucRand
            app.PerSucRand = uicheckbox(app.DatosPerdidas);
            app.PerSucRand.ValueChangedFcn = createCallbackFcn(app, @PerSucRandValueChanged);
            app.PerSucRand.Text = '';
            app.PerSucRand.Position = [328 12 22 16];

            % Create Tab
            app.Tab = uitab(app.DatosSimulacion);
            app.Tab.Units = 'pixels';
            app.Tab.Title = 'N de mdulos e Interconexin';

            % Create LabelNumericEditField
            app.LabelNumericEditField = uilabel(app.Tab);
            app.LabelNumericEditField.HorizontalAlignment = 'right';
            app.LabelNumericEditField.Position = [38 85 60 15];
            app.LabelNumericEditField.Text = 'M. en serie';

            % Create ModulosSerie
            app.ModulosSerie = uieditfield(app.Tab, 'numeric');
            app.ModulosSerie.ValueChangedFcn = createCallbackFcn(app, @ModulosSerieValueChanged);
            app.ModulosSerie.Limits = [1 Inf];
            app.ModulosSerie.Position = [113 81 67 22];
            app.ModulosSerie.Value = 1;

            % Create Label27
            app.Label27 = uilabel(app.Tab);
            app.Label27.HorizontalAlignment = 'right';
            app.Label27.Position = [20 50 78 15];
            app.Label27.Text = 'M. en paralelo';

            % Create ModulosParalelo
            app.ModulosParalelo = uieditfield(app.Tab, 'numeric');
            app.ModulosParalelo.ValueChangedFcn = createCallbackFcn(app, @ModulosParaleloValueChanged);
            app.ModulosParalelo.Limits = [1 Inf];
            app.ModulosParalelo.Position = [113 46 67 22];
            app.ModulosParalelo.Value = 1;

            % Create LabelNumericEditField6
            app.LabelNumericEditField6 = uilabel(app.Tab);
            app.LabelNumericEditField6.HorizontalAlignment = 'right';
            app.LabelNumericEditField6.Position = [192 50 52 15];
            app.LabelNumericEditField6.Text = 'M. totales';

            % Create NumeroModulos
            app.NumeroModulos = uieditfield(app.Tab, 'numeric');
            app.NumeroModulos.ValueDisplayFormat = '%11.10g';
            app.NumeroModulos.Editable = 'off';
            app.NumeroModulos.FontSize = 36;
            app.NumeroModulos.Position = [258 35 125 44];
            app.NumeroModulos.Value = 1;

            % Create Label32
            app.Label32 = uilabel(app.Tab);
            app.Label32.HorizontalAlignment = 'right';
            app.Label32.Position = [28 17 70 15];
            app.Label32.Text = 'Multiplicador';

            % Create MultiplicadorModulos
            app.MultiplicadorModulos = uieditfield(app.Tab, 'numeric');
            app.MultiplicadorModulos.ValueChangedFcn = createCallbackFcn(app, @MultiplicadorModulosValueChanged);
            app.MultiplicadorModulos.Limits = [1 Inf];
            app.MultiplicadorModulos.Position = [113 13 67 22];
            app.MultiplicadorModulos.Value = 1;
        end
    end

    methods (Access = public)

        % Construct app
        function app = PreciSol()

            % Create and configure components
            createComponents(app)

            % Register the app with App Designer
            registerApp(app, app.PreciSolApp)

            % Execute the startup function
            runStartupFcn(app, @startupFcn)

            if nargout == 0
                clear app
            end
        end

        % Code that executes before app deletion
        function delete(app)

            % Delete UIFigure when app is deleted
            delete(app.PreciSolApp)
        end
    end
end