function save_data(G_Gh, T_a, T_c, P, V_pmax, I_pmax, start_month, start_day, ...
    end_month, end_day, M_series, M_parallel, M_total)
% -----------------------------------------------------------------------
% Funcin "file_fuser":
%     sta funcin tiene como objetivo guardar en un fichero .dat los
% resultados obtenidos en la simulacin.
% -----------------------------------------------------------------------

% Otencin del directorio de guardado
file_path = uigetdir(pwd);
% Obtencin del nombre de fichero
start_month = get_month(start_month);
start_month = start_month(1:3);
start_day = num2str(start_day);
end_month = get_month(end_month);
end_month = end_month(1:3);
end_day = num2str(end_day);
M_series = num2str(M_series);
M_parallel = num2str(M_parallel);
M_total = num2str(M_total);
filename = strcat(file_path, '\sim_', start_month, start_day, '_', ...
    end_month, end_day, '_s', M_series, 'p', M_parallel, 't', M_total, ...
    '.dat');

% Inicio de barra de progreso
progressbar(0);
progressbar('Creando fichero...');

% Apertura de fichero de guardado
fid = fopen(filename, 'wt');
% Formato en columnas del fichero
formatspec = '%0.0f\t%0.1f\t%0.1f\t%0.0f\t%0.1f\t%0.1f\r\n';

% Escritura fila a fila
for i = 1:length(G_Gh)
    file_vec = [G_Gh(i); T_a(i); T_c(i); P(i); V_pmax(i); I_pmax(i)];
    fprintf(fid, formatspec, file_vec);
    progressbar((1/length(G_Gh))*i);
end

% Cierre de fichero y barra de progreso
fclose(fid);
progressbar(1);